<template>
    <div v-if="items.length">
        <b-table striped hover responsive :fields="fields" fixed :items="items">
            <template #cell(action)="data">
                <b-button size="sm" @click="deleteIdea(data.item._id)" class="mr-2">
                    Supprimer
                </b-button>
                <b-button size="sm" @click="updateIdea(data.item)" class="mr-2">
                    Modifier
                </b-button>
            </template>
        </b-table>
    </div>
    <div v-else="items.length">
        Aucune idée troové !
    </div>
</template>

<script>
export default {
    name: 'List',
    methods: {
        deleteIdea: async function (id) {
            await this.$axios.$delete(`/idea/${id}`);
            await this.$nuxt.refresh();
        },
        updateIdea: function (data) {
            this.$router.push({ name: 'idea', params: { idea: data } })
        },
    },
    data() {
        return {
            items: [],
            fields: [{ label: 'Identifiant', key: '_id' },
            { label: 'Titre', key: 'title' },
            { label: 'Description', key: 'description' },
            { label: 'Créée le', key: 'createdAt' },
            { label: 'Mise à jour le', key: 'updatedAt' },
            { label: 'Version', key: '__v' },
            { label: 'Action(s)', key: 'action' }
            ]
        }
    },
    async fetch() {
        const res = await this.$axios.get('/idea');
        this.items = res.data.ideas
    },
    fetchOnServer: false
}
</script>
